#pragma once
/** Template abstraction for 2D Shapes. */
template <class T>
class Shape{
public:
  /** Constructor fixing the length-scale of the shape. */
  Shape(const float scale): m_scale(scale), m_specificShape(){
  }
  /** Passes the area calculation to an object of the specified type.*/
  float getArea() const {
    return m_specificShape.getArea(m_scale);
  }
  /** Common function to all shapes implemented in this abstraction.*/
  float getScale() const {
    return m_scale;
  }
private:
  //Alternative to private inheritance: Object Composition
  T m_specificShape;
  float m_scale;
};

